import { Directive, Self, Host, ElementRef } from '@angular/core';
import { VirtualScroll, Content } from 'ionic-angular';
var AnimListItemsDirective = (function () {
    function AnimListItemsDirective(virtualScroll, content, elementRef) {
        this.virtualScroll = virtualScroll;
        this.content = content;
        this.sb = [];
        this.sb.push(content.ionScroll.subscribe(this.onScroll.bind(this)));
        this.sb.push(content.ionScrollEnd.subscribe(this.onScrollEnd.bind(this)));
        this.original_renderVirtual = virtualScroll.renderVirtual;
        virtualScroll.renderVirtual = this.overrodeRenderVirtual.bind(this);
        // let ob = new MutationObserver(() => {
        //     setTimeout(() => {
        //         this.updateItems();
        //     });
        //     ob.disconnect();
        // });
        // ob.observe(elementRef.nativeElement, { childList: true });
    }
    // ngAfterViewInit() {
    //     let sb = this.children.changes.subscribe(() => {
    //         this.updateItems();
    //         sb.unsubscribe();
    //     });
    // }
    // ngAfterViewInit() {
    //     let sb = this.children.changes.subscribe(() => {
    //         this.updateItems();
    //         sb.unsubscribe();
    //     });
    // }
    AnimListItemsDirective.prototype.ngOnDestroy = 
    // ngAfterViewInit() {
    //     let sb = this.children.changes.subscribe(() => {
    //         this.updateItems();
    //         sb.unsubscribe();
    //     });
    // }
    function () {
        this.sb.forEach(function (a) { return a && a.unsubscribe && a.unsubscribe(); });
        this.sb = [];
    };
    AnimListItemsDirective.prototype.overrodeRenderVirtual = function (needClean) {
        this.original_renderVirtual.apply(this.virtualScroll, [needClean]);
        this.updateItems();
    };
    AnimListItemsDirective.prototype.onScroll = function () {
        // https://github.com/ionic-team/ionic/blob/master/src/components/virtual-scroll/virtual-scroll.ts#L721
        if (this.virtualScroll._queue !== 1 /* ScrollQueue.NoChanges */ &&
            this.virtualScroll._queue !== 2 /* ScrollQueue.ChangeDetection */) {
            this.updateItems();
        }
    };
    AnimListItemsDirective.prototype.onScrollEnd = function () {
        // setTimeout(() => {
        this.updateItems();
        // });
    };
    AnimListItemsDirective.prototype.updateItems = function () {
        if (this.locked) {
            this.nextCall = true;
        }
        else {
            this.nextCall = false;
            this.locked = true;
            // this.original_stepDOMWrite.apply(this.virtualScroll);
            this.updateItemsInternal();
        }
    };
    AnimListItemsDirective.prototype.updateItemsInternal = function () {
        var isScrollingUp = this.lastScrollTop > this.content.scrollTop;
        this.lastScrollTop = this.content.scrollTop;
        var newVisibleItemIndex = 0;
        var newInvisibleItemIndex = 0;
        var nodes = this.virtualScroll._nodes.sort(function (a, b) { return (a.cell > b.cell ? 1 : -1) * (isScrollingUp ? -1 : 1); });
        var cells = this.virtualScroll._cells;
        for (var i = 0, l = nodes.length; i < l; i++) {
            var node = nodes[i];
            var cell = cells[node.cell];
            var inViewport = this.isInViewport(node, cell);
            if (inViewport) {
                if (node.wasInViewport) {
                    var element = this.getElement(node);
                    // element.classList.remove('anim-listitem-exit');
                }
                else {
                    this.animEnter(node, cell, newVisibleItemIndex, isScrollingUp);
                    newVisibleItemIndex++;
                }
            }
            else {
                if (node.wasInViewport) {
                    this.animExit(node, cell, newInvisibleItemIndex, isScrollingUp);
                    newInvisibleItemIndex++;
                }
                else {
                    var element = this.getElement(node);
                    element.classList.remove('anim-listitem-visible');
                }
            }
            node.wasInViewport = inViewport;
        }
        // setTimeout(() => {
        this.locked = false;
        if (this.nextCall) {
            this.updateItems();
        }
        // });
    };
    AnimListItemsDirective.prototype.isInViewport = function (node, cell) {
        if (!this.viewport) {
            this.viewport = this.content._scrollContent.nativeElement;
        }
        if (this.viewport.clientTop < (cell.top + cell.height - this.viewport.scrollTop) &&
            (this.viewport.clientTop + this.viewport.clientHeight) > (cell.top - this.viewport.scrollTop)) {
            return true;
        }
        return false;
    };
    AnimListItemsDirective.prototype.animEnter = function (node, cell, newVisibleItemIndex, isScrollingUp) {
        var element = this.getElement(node);
        element.classList.remove("anim-listitem-" + node._prevIndex);
        node._prevIndex = newVisibleItemIndex;
        element.classList.add('anim-listitem-' + newVisibleItemIndex);
        element.classList.add('anim-listitem-visible');
    };
    AnimListItemsDirective.prototype.animExit = function (node, cell, newVisibleItemIndex, isScrollingUp) {
        var element = this.getElement(node);
        element.classList.remove('anim-listitem-top');
        element.classList.remove('anim-listitem-bottom');
        element.classList.remove("anim-listitem-" + node._prevIndex);
        node._prevIndex = newVisibleItemIndex;
        element.classList.add('anim-listitem-' + newVisibleItemIndex);
        element.classList.remove("anim-listitem-" + (isScrollingUp ? 'top' : 'bottom'));
    };
    AnimListItemsDirective.prototype.getElement = function (node) {
        var rootNodes = node.view.rootNodes;
        for (var i = 0; i < rootNodes.length; i++) {
            if (rootNodes[i].nodeType === 1) {
                return rootNodes[i];
            }
        }
        return null;
    };
    AnimListItemsDirective.decorators = [
        { type: Directive, args: [{ selector: '[animListItems]' },] },
    ];
    /** @nocollapse */
    AnimListItemsDirective.ctorParameters = function () { return [
        { type: VirtualScroll, decorators: [{ type: Self }, { type: Host },] },
        { type: Content, decorators: [{ type: Host },] },
        { type: ElementRef, },
    ]; };
    return AnimListItemsDirective;
}());
export { AnimListItemsDirective };
//# sourceMappingURL=AnimListItems.js.map